import { Morphir_IR_AccessControlled } from "./../../morphir/ir/AccessControlled";
import { Morphir_IR_Documented } from "./../../morphir/ir/Documented";
import { Morphir_IR_Name } from "./../../morphir/ir/Name";
import { Morphir_IR_Path } from "./../../morphir/ir/Path";
import { Morphir_IR_Type } from "./../../morphir/ir/Type";
import { Morphir_IR_Value } from "./../../morphir/ir/Value";
export declare namespace Morphir_IR_Module {
    type Definition<Ta, Va> = {
        types: Map<Morphir_IR_Name.Name, Morphir_IR_AccessControlled.AccessControlled<Morphir_IR_Documented.Documented<Morphir_IR_Type.Definition<Ta>>>>;
        values: Map<Morphir_IR_Name.Name, Morphir_IR_AccessControlled.AccessControlled<Morphir_IR_Documented.Documented<Morphir_IR_Value.Definition<Ta, Va>>>>;
        doc: string | null;
    };
    function decodeDefinition<Ta, Va>(decodeTa: (input: any) => Ta, decodeVa: (input: any) => Va, input: any): Definition<Ta, Va>;
    function encodeDefinition<Ta, Va>(encodeTa: (value: Ta) => any, encodeVa: (value: Va) => any, value: Definition<Ta, Va>): any;
    type ModuleName = Morphir_IR_Path.Path;
    function decodeModuleName(input: any): ModuleName;
    function encodeModuleName(value: ModuleName): any;
    type QualifiedModuleName = [
        Morphir_IR_Path.Path,
        Morphir_IR_Path.Path
    ];
    function decodeQualifiedModuleName(input: any): QualifiedModuleName;
    function encodeQualifiedModuleName(value: QualifiedModuleName): any;
    type Specification<Ta> = {
        types: Map<Morphir_IR_Name.Name, Morphir_IR_Documented.Documented<Morphir_IR_Type.Specification<Ta>>>;
        values: Map<Morphir_IR_Name.Name, Morphir_IR_Documented.Documented<Morphir_IR_Value.Specification<Ta>>>;
        doc: string | null;
    };
    function decodeSpecification<Ta>(decodeTa: (input: any) => Ta, input: any): Specification<Ta>;
    function encodeSpecification<Ta>(encodeTa: (value: Ta) => any, value: Specification<Ta>): any;
}
