import { Morphir_IR_AccessControlled } from "./../../morphir/ir/AccessControlled";
import { Morphir_IR_FQName } from "./../../morphir/ir/FQName";
import { Morphir_IR_Name } from "./../../morphir/ir/Name";
export declare namespace Morphir_IR_Type {
    type Constructor<A> = [
        Morphir_IR_Name.Name,
        Morphir_IR_Type.ConstructorArgs<A>
    ];
    function decodeConstructor<A>(decodeA: (input: any) => A, input: any): Constructor<A>;
    function encodeConstructor<A>(encodeA: (value: A) => any, value: Constructor<A>): any;
    type ConstructorArgs<A> = Array<[
        Morphir_IR_Name.Name,
        Morphir_IR_Type.Type<A>
    ]>;
    function decodeConstructorArgs<A>(decodeA: (input: any) => A, input: any): ConstructorArgs<A>;
    function encodeConstructorArgs<A>(encodeA: (value: A) => any, value: ConstructorArgs<A>): any;
    type Constructors<A> = Map<Morphir_IR_Name.Name, Morphir_IR_Type.ConstructorArgs<A>>;
    function decodeConstructors<A>(decodeA: (input: any) => A, input: any): Constructors<A>;
    function encodeConstructors<A>(encodeA: (value: A) => any, value: Constructors<A>): any;
    type Definition<A> = CustomTypeDefinition<A> | TypeAliasDefinition<A>;
    function decodeDefinition<A>(decodeA: (input: any) => A, input: any): Definition<A>;
    function encodeDefinition<A>(encodeA: (value: A) => any, value: Definition<A>): any;
    class CustomTypeDefinition<A> {
        arg1: Array<Morphir_IR_Name.Name>;
        arg2: Morphir_IR_AccessControlled.AccessControlled<Morphir_IR_Type.Constructors<A>>;
        kind: "CustomTypeDefinition";
        constructor(arg1: Array<Morphir_IR_Name.Name>, arg2: Morphir_IR_AccessControlled.AccessControlled<Morphir_IR_Type.Constructors<A>>);
    }
    function decodeCustomTypeDefinition<A>(decodeA: (input: any) => A, input: any): CustomTypeDefinition<A>;
    function encodeCustomTypeDefinition<A>(encodeA: (value: A) => any, value: CustomTypeDefinition<A>): any;
    class TypeAliasDefinition<A> {
        arg1: Array<Morphir_IR_Name.Name>;
        arg2: Morphir_IR_Type.Type<A>;
        kind: "TypeAliasDefinition";
        constructor(arg1: Array<Morphir_IR_Name.Name>, arg2: Morphir_IR_Type.Type<A>);
    }
    function decodeTypeAliasDefinition<A>(decodeA: (input: any) => A, input: any): TypeAliasDefinition<A>;
    function encodeTypeAliasDefinition<A>(encodeA: (value: A) => any, value: TypeAliasDefinition<A>): any;
    type DerivedTypeSpecificationDetails<A> = {
        baseType: Morphir_IR_Type.Type<A>;
        fromBaseType: Morphir_IR_FQName.FQName;
        toBaseType: Morphir_IR_FQName.FQName;
    };
    function decodeDerivedTypeSpecificationDetails<A>(decodeA: (input: any) => A, input: any): DerivedTypeSpecificationDetails<A>;
    function encodeDerivedTypeSpecificationDetails<A>(encodeA: (value: A) => any, value: DerivedTypeSpecificationDetails<A>): any;
    type Field<A> = {
        name: Morphir_IR_Name.Name;
        tpe: Morphir_IR_Type.Type<A>;
    };
    function decodeField<A>(decodeA: (input: any) => A, input: any): Field<A>;
    function encodeField<A>(encodeA: (value: A) => any, value: Field<A>): any;
    type Specification<A> = CustomTypeSpecification<A> | DerivedTypeSpecification<A> | OpaqueTypeSpecification | TypeAliasSpecification<A>;
    function decodeSpecification<A>(decodeA: (input: any) => A, input: any): Specification<A>;
    function encodeSpecification<A>(encodeA: (value: A) => any, value: Specification<A>): any;
    class CustomTypeSpecification<A> {
        arg1: Array<Morphir_IR_Name.Name>;
        arg2: Morphir_IR_Type.Constructors<A>;
        kind: "CustomTypeSpecification";
        constructor(arg1: Array<Morphir_IR_Name.Name>, arg2: Morphir_IR_Type.Constructors<A>);
    }
    function decodeCustomTypeSpecification<A>(decodeA: (input: any) => A, input: any): CustomTypeSpecification<A>;
    function encodeCustomTypeSpecification<A>(encodeA: (value: A) => any, value: CustomTypeSpecification<A>): any;
    class DerivedTypeSpecification<A> {
        arg1: Array<Morphir_IR_Name.Name>;
        arg2: Morphir_IR_Type.DerivedTypeSpecificationDetails<A>;
        kind: "DerivedTypeSpecification";
        constructor(arg1: Array<Morphir_IR_Name.Name>, arg2: Morphir_IR_Type.DerivedTypeSpecificationDetails<A>);
    }
    function decodeDerivedTypeSpecification<A>(decodeA: (input: any) => A, input: any): DerivedTypeSpecification<A>;
    function encodeDerivedTypeSpecification<A>(encodeA: (value: A) => any, value: DerivedTypeSpecification<A>): any;
    class OpaqueTypeSpecification {
        arg1: Array<Morphir_IR_Name.Name>;
        kind: "OpaqueTypeSpecification";
        constructor(arg1: Array<Morphir_IR_Name.Name>);
    }
    function decodeOpaqueTypeSpecification(input: any): OpaqueTypeSpecification;
    function encodeOpaqueTypeSpecification(value: OpaqueTypeSpecification): any;
    class TypeAliasSpecification<A> {
        arg1: Array<Morphir_IR_Name.Name>;
        arg2: Morphir_IR_Type.Type<A>;
        kind: "TypeAliasSpecification";
        constructor(arg1: Array<Morphir_IR_Name.Name>, arg2: Morphir_IR_Type.Type<A>);
    }
    function decodeTypeAliasSpecification<A>(decodeA: (input: any) => A, input: any): TypeAliasSpecification<A>;
    function encodeTypeAliasSpecification<A>(encodeA: (value: A) => any, value: TypeAliasSpecification<A>): any;
    type Type<A> = ExtensibleRecord<A> | Function<A> | Record<A> | Reference<A> | Tuple<A> | Unit<A> | Variable<A>;
    function decodeType<A>(decodeA: (input: any) => A, input: any): Type<A>;
    function encodeType<A>(encodeA: (value: A) => any, value: Type<A>): any;
    class ExtensibleRecord<A> {
        arg1: A;
        arg2: Morphir_IR_Name.Name;
        arg3: Array<Morphir_IR_Type.Field<A>>;
        kind: "ExtensibleRecord";
        constructor(arg1: A, arg2: Morphir_IR_Name.Name, arg3: Array<Morphir_IR_Type.Field<A>>);
    }
    function decodeExtensibleRecord<A>(decodeA: (input: any) => A, input: any): ExtensibleRecord<A>;
    function encodeExtensibleRecord<A>(encodeA: (value: A) => any, value: ExtensibleRecord<A>): any;
    class Function<A> {
        arg1: A;
        arg2: Morphir_IR_Type.Type<A>;
        arg3: Morphir_IR_Type.Type<A>;
        kind: "Function";
        constructor(arg1: A, arg2: Morphir_IR_Type.Type<A>, arg3: Morphir_IR_Type.Type<A>);
    }
    function decodeFunction<A>(decodeA: (input: any) => A, input: any): Function<A>;
    function encodeFunction<A>(encodeA: (value: A) => any, value: Function<A>): any;
    class Record<A> {
        arg1: A;
        arg2: Array<Morphir_IR_Type.Field<A>>;
        kind: "Record";
        constructor(arg1: A, arg2: Array<Morphir_IR_Type.Field<A>>);
    }
    function decodeRecord<A>(decodeA: (input: any) => A, input: any): Record<A>;
    function encodeRecord<A>(encodeA: (value: A) => any, value: Record<A>): any;
    class Reference<A> {
        arg1: A;
        arg2: Morphir_IR_FQName.FQName;
        arg3: Array<Morphir_IR_Type.Type<A>>;
        kind: "Reference";
        constructor(arg1: A, arg2: Morphir_IR_FQName.FQName, arg3: Array<Morphir_IR_Type.Type<A>>);
    }
    function decodeReference<A>(decodeA: (input: any) => A, input: any): Reference<A>;
    function encodeReference<A>(encodeA: (value: A) => any, value: Reference<A>): any;
    class Tuple<A> {
        arg1: A;
        arg2: Array<Morphir_IR_Type.Type<A>>;
        kind: "Tuple";
        constructor(arg1: A, arg2: Array<Morphir_IR_Type.Type<A>>);
    }
    function decodeTuple<A>(decodeA: (input: any) => A, input: any): Tuple<A>;
    function encodeTuple<A>(encodeA: (value: A) => any, value: Tuple<A>): any;
    class Unit<A> {
        arg1: A;
        kind: "Unit";
        constructor(arg1: A);
    }
    function decodeUnit<A>(decodeA: (input: any) => A, input: any): Unit<A>;
    function encodeUnit<A>(encodeA: (value: A) => any, value: Unit<A>): any;
    class Variable<A> {
        arg1: A;
        arg2: Morphir_IR_Name.Name;
        kind: "Variable";
        constructor(arg1: A, arg2: Morphir_IR_Name.Name);
    }
    function decodeVariable<A>(decodeA: (input: any) => A, input: any): Variable<A>;
    function encodeVariable<A>(encodeA: (value: A) => any, value: Variable<A>): any;
}
