/*
Copyright 2020 Morgan Stanley

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package morphir.sdk

import morphir.sdk.Maybe.Maybe

private[sdk] trait MaybeLike[+A] extends Product with Serializable

private[sdk] object MaybeLike {
  def maybe2Iterable[A](xo: Maybe[A]): Iterable[A] =
    if (xo.isEmpty) List.empty.toIterable else List(xo.get).toIterable
}
